/*
Copyright (C) 2003-2008 Anders Ervik <calvin@countzero.no>
Copyright (C) 2006-2008 Leonard Ritter <contact@leonard-ritter.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* autogenerated from c:\code\buze\trunk\buze\src\armstrong\include\zzub\zzub.zidl */

#if !defined(__ZZUB_H)
#define __ZZUB_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "zzub/types.h"

/* namespace zzub */

typedef struct zzub_event_data zzub_event_data_t;
typedef struct zzub_event_data_all zzub_event_data_all_t;
typedef struct zzub_event_data_double_click zzub_event_data_double_click_t;
typedef struct zzub_event_data_insert_plugin zzub_event_data_insert_plugin_t;
typedef struct zzub_event_data_delete_plugin zzub_event_data_delete_plugin_t;
typedef struct zzub_event_data_update_plugin zzub_event_data_update_plugin_t;
typedef struct zzub_event_data_insert_connection zzub_event_data_insert_connection_t;
typedef struct zzub_event_data_update_connection zzub_event_data_update_connection_t;
typedef struct zzub_event_data_delete_connection zzub_event_data_delete_connection_t;
typedef struct zzub_event_data_insert_pattern zzub_event_data_insert_pattern_t;
typedef struct zzub_event_data_update_pattern zzub_event_data_update_pattern_t;
typedef struct zzub_event_data_delete_pattern zzub_event_data_delete_pattern_t;
typedef struct zzub_event_data_insert_pattern_event zzub_event_data_insert_pattern_event_t;
typedef struct zzub_event_data_update_pattern_event zzub_event_data_update_pattern_event_t;
typedef struct zzub_event_data_delete_pattern_event zzub_event_data_delete_pattern_event_t;
typedef struct zzub_event_data_insert_pattern_format zzub_event_data_insert_pattern_format_t;
typedef struct zzub_event_data_update_pattern_format zzub_event_data_update_pattern_format_t;
typedef struct zzub_event_data_delete_pattern_format zzub_event_data_delete_pattern_format_t;
typedef struct zzub_event_data_insert_pattern_format_column zzub_event_data_insert_pattern_format_column_t;
typedef struct zzub_event_data_update_pattern_format_column zzub_event_data_update_pattern_format_column_t;
typedef struct zzub_event_data_delete_pattern_format_column zzub_event_data_delete_pattern_format_column_t;
typedef struct zzub_event_data_midi_message zzub_event_data_midi_message_t;
typedef struct zzub_event_data_update_plugin_parameter zzub_event_data_update_plugin_parameter_t;
typedef struct zzub_event_data_player_state_changed zzub_event_data_player_state_changed_t;
typedef struct zzub_event_data_player_order_changed zzub_event_data_player_order_changed_t;
typedef struct zzub_event_data_vu zzub_event_data_vu_t;
typedef struct zzub_event_data_serialize zzub_event_data_serialize_t;
typedef struct zzub_event_data_unknown zzub_event_data_unknown_t;
typedef struct zzub_event_data_osc_message zzub_event_data_osc_message_t;
typedef struct zzub_event_data_insert_wave zzub_event_data_insert_wave_t;
typedef struct zzub_event_data_update_wave zzub_event_data_update_wave_t;
typedef struct zzub_event_data_delete_wave zzub_event_data_delete_wave_t;
typedef struct zzub_event_data_insert_wavelevel zzub_event_data_insert_wavelevel_t;
typedef struct zzub_event_data_update_wavelevel zzub_event_data_update_wavelevel_t;
typedef struct zzub_event_data_update_wavelevel_samples zzub_event_data_update_wavelevel_samples_t;
typedef struct zzub_event_data_delete_wavelevel zzub_event_data_delete_wavelevel_t;
typedef struct zzub_event_data_custom zzub_event_data_custom_t;
typedef struct zzub_event_data_user_alert zzub_event_data_user_alert_t;

/** \brief Methods for enumerating, configuring and creating an audio driver instance.
	Implements both the RtAudio and PortAudio APIs. */
#if !defined(NO_ZZUB_AUDIODRIVER_TYPE)
typedef struct _zzub_audiodriver zzub_audiodriver_t;
#endif

/** \brief Methods for enumerating and opening MIDI input and output devices. */
#if !defined(NO_ZZUB_MIDIDRIVER_TYPE)
typedef struct _zzub_mididriver zzub_mididriver_t;
#endif

/** \brief For enumerating and configuring plugin collections. */
#if !defined(NO_ZZUB_PLUGINCOLLECTION_TYPE)
typedef struct _zzub_plugincollection zzub_plugincollection_t;
#endif

/** \brief Methods for working with file- or memory-based input streams. E.g reading from a file or buffer. */
#if !defined(NO_ZZUB_INPUT_TYPE)
typedef struct _zzub_input zzub_input_t;
#endif

/** \brief Methods for working with file- or memory-based output streams. E.g writing to a file or buffer. */
#if !defined(NO_ZZUB_OUTPUT_TYPE)
typedef struct _zzub_output zzub_output_t;
#endif

/** \brief Methods for working with in-memory streams. */
#if !defined(NO_ZZUB_ARCHIVE_TYPE)
typedef struct _zzub_archive zzub_archive_t;
#endif

/** \brief Represents a binding between a MIDI controller and a plugin parameter.
	To create a MIDI mapping, see zzub_player_add_midimapping(). */
#if !defined(NO_ZZUB_MIDIMAPPING_TYPE)
typedef struct _zzub_midimapping zzub_midimapping_t;
#endif

/** \brief Represents an event in a pattern. */
#if !defined(NO_ZZUB_PATTERN_EVENT_TYPE)
typedef struct _zzub_pattern_event zzub_pattern_event_t;
#endif

/** \brief Helper iterator for a range of patterns. */
#if !defined(NO_ZZUB_PATTERN_ITERATOR_TYPE)
typedef struct _zzub_pattern_iterator zzub_pattern_iterator_t;
#endif

/** \brief Helper iterator for a range of pattern events. */
#if !defined(NO_ZZUB_PATTERN_EVENT_ITERATOR_TYPE)
typedef struct _zzub_pattern_event_iterator zzub_pattern_event_iterator_t;
#endif

/** \brief Methods for working with a pattern.
	The format of a pattern is completely dynamic, defined by a zzub_pattern_format.
	To create a new pattern, see zzub_player_create_pattern(). */
#if !defined(NO_ZZUB_PATTERN_TYPE)
typedef struct _zzub_pattern zzub_pattern_t;
#endif

/** \brief Container class for which columns to refer in a pattern.
	To create a new pattern format, see zzub_player_create_pattern_format().
	@SEEALSO: Pattern, PatternFormatIterator, PatternFormatColumn, PatternFormatColumnIterator */
#if !defined(NO_ZZUB_PATTERN_FORMAT_TYPE)
typedef struct _zzub_pattern_format zzub_pattern_format_t;
#endif

/** \brief Helper iterator for a range of pattern formats. */
#if !defined(NO_ZZUB_PATTERN_FORMAT_ITERATOR_TYPE)
typedef struct _zzub_pattern_format_iterator zzub_pattern_format_iterator_t;
#endif

/** \brief Represents a column in a pattern. */
#if !defined(NO_ZZUB_PATTERN_FORMAT_COLUMN_TYPE)
typedef struct _zzub_pattern_format_column zzub_pattern_format_column_t;
#endif

/** \brief Helper iterator for a range of pattern format columns. */
#if !defined(NO_ZZUB_PATTERN_FORMAT_COLUMN_ITERATOR_TYPE)
typedef struct _zzub_pattern_format_column_iterator zzub_pattern_format_column_iterator_t;
#endif

/** \brief Represents a plugin parameter. */
#if !defined(NO_ZZUB_PARAMETER_TYPE)
typedef struct _zzub_parameter zzub_parameter_t;
#endif

/** \brief Represents a plugin attribute.
	Attributes are similar to plugin parameters, but they cannot be automated. */
#if !defined(NO_ZZUB_ATTRIBUTE_TYPE)
typedef struct _zzub_attribute zzub_attribute_t;
#endif

/** \brief Represents the description of a plugin type.
	Provides access to static properties of a plugin, such as parameter descriptions, attributes, tracks and channel descriptions. */
#if !defined(NO_ZZUB_PLUGINLOADER_TYPE)
typedef struct _zzub_pluginloader zzub_pluginloader_t;
#endif

/** \brief Plugin methods
	Retreive more details about plugins. */
#if !defined(NO_ZZUB_PLUGIN_TYPE)
typedef struct _zzub_plugin zzub_plugin_t;
#endif

/** \brief Helper iterator for a range of plugins. */
#if !defined(NO_ZZUB_PLUGIN_ITERATOR_TYPE)
typedef struct _zzub_plugin_iterator zzub_plugin_iterator_t;
#endif

/** \brief Describes a connection between two plugins.
	There are three kinds of connections: Audio, MIDI and event connections.
	To create a connection, see zzub_player_create_audio_connection(), zzub_player_create_midi_connection() and zzub_player_create_event_connection(). */
#if !defined(NO_ZZUB_CONNECTION_TYPE)
typedef struct _zzub_connection zzub_connection_t;
#endif

/** \brief Event connection binding between a controller plugin and a parameter on the connected plugin. */
#if !defined(NO_ZZUB_CONNECTION_BINDING_TYPE)
typedef struct _zzub_connection_binding zzub_connection_binding_t;
#endif

/** \brief Collection of event connection bindings. */
#if !defined(NO_ZZUB_CONNECTION_BINDING_ITERATOR_TYPE)
typedef struct _zzub_connection_binding_iterator zzub_connection_binding_iterator_t;
#endif

/** \brief Wave table */
#if !defined(NO_ZZUB_WAVE_TYPE)
typedef struct _zzub_wave zzub_wave_t;
#endif

/** \brief Wavelevel */
#if !defined(NO_ZZUB_WAVELEVEL_TYPE)
typedef struct _zzub_wavelevel zzub_wavelevel_t;
#endif

/** \brief Envelopes */
#if !defined(NO_ZZUB_ENVELOPE_TYPE)
typedef struct _zzub_envelope zzub_envelope_t;
#endif

/** \brief Mixer Methods - provides access to the mixer in native plugins */
#if !defined(NO_ZZUB_MIXER_TYPE)
typedef struct _zzub_mixer zzub_mixer_t;
#endif

/** \brief Contains validation warnings and errors.
	Validation errors are created when plugin incompabilities are detected.
	E.g if an older plugin was used to save a song, or was in the plugin cache. */
#if !defined(NO_ZZUB_VALIDATION_ERROR_ITERATOR_TYPE)
typedef struct _zzub_validation_error_iterator zzub_validation_error_iterator_t;
#endif

/** \brief Used by song importers for details about compatibility problems with plugins and parameters during load. */
#if !defined(NO_ZZUB_VALIDATION_ERROR_TYPE)
typedef struct _zzub_validation_error zzub_validation_error_t;
#endif

/** \brief Player Methods */
#if !defined(NO_ZZUB_PLAYER_TYPE)
typedef struct _zzub_player zzub_player_t;
#endif
enum {
	zzub_version = 15,
	zzub_buffer_size = 256,
};

enum zzub_event_type {
	zzub_event_type_double_click = 0,
	zzub_event_type_update_song = 60,
	zzub_event_type_insert_plugin = 1,
	zzub_event_type_before_delete_plugin = 5,
	zzub_event_type_delete_plugin = 2,
	zzub_event_type_update_plugin = 30,
	zzub_event_type_insert_connection = 4,
	zzub_event_type_delete_connection = 3,
	zzub_event_type_update_connection = 68,
	zzub_event_type_update_pluginparameter = 7,
	zzub_event_type_insert_pattern = 25,
	zzub_event_type_update_pattern = 31,
	zzub_event_type_delete_pattern = 26,
	zzub_event_type_insert_patternevent = 27,
	zzub_event_type_update_patternevent = 48,
	zzub_event_type_delete_patternevent = 49,
	zzub_event_type_insert_orderlist = 32,
	zzub_event_type_delete_orderlist = 33,
	zzub_event_type_update_orderlist = 41,
	zzub_event_type_insert_patternformat = 52,
	zzub_event_type_update_patternformat = 61,
	zzub_event_type_delete_patternformat = 53,
	zzub_event_type_insert_patternformatcolumn = 54,
	zzub_event_type_update_patternformatcolumn = 62,
	zzub_event_type_delete_patternformatcolumn = 55,
	zzub_event_type_insert_patternformattrack = 63,
	zzub_event_type_update_patternformattrack = 64,
	zzub_event_type_delete_patternformattrack = 65,
	zzub_event_type_envelope_changed = 37,
	zzub_event_type_slices_changed = 38,
	zzub_event_type_insert_wave = 56,
	zzub_event_type_update_wave = 39,
	zzub_event_type_delete_wave = 40,
	zzub_event_type_insert_wavelevel = 12,
	zzub_event_type_update_wavelevel = 57,
	zzub_event_type_delete_wavelevel = 58,
	zzub_event_type_update_wavelevel_samples = 59,
	zzub_event_type_user_alert = 8,
	zzub_event_type_midi_control = 11,
	zzub_event_type_player_state_changed = 20,
	zzub_event_type_osc_message = 21,
	zzub_event_type_vu = 22,
	zzub_event_type_player_order_changed = 69,
	zzub_event_type_player_order_queue_changed = 70,
	zzub_event_type_custom = 44,
	zzub_event_type_samplerate_changed = 50,
	zzub_event_type_barrier = 51,
	zzub_event_type_all = 255,
};

enum zzub_player_state {
	zzub_player_state_playing = 0,
	zzub_player_state_stopped = 1,
	zzub_player_state_muted = 2,
	zzub_player_state_released = 3,
};

enum zzub_alert_type {
	zzub_alert_type_enumeratingplugins = 1,
	zzub_alert_type_enumeratingpluginsdone = 2,
	zzub_alert_type_mixdownprogress = 20,
	zzub_alert_type_loadingplugins = 100,
	zzub_alert_type_loadingpatterns = 101,
	zzub_alert_type_loadingwaves = 102,
	zzub_alert_type_patternrecursion = 400,
};

enum zzub_parameter_type {
	zzub_parameter_type_note = 0,
	zzub_parameter_type_switch = 1,
	zzub_parameter_type_byte = 2,
	zzub_parameter_type_word = 3,
	zzub_parameter_type_meta = 4,
};

enum zzub_wave_buffer_type {
	zzub_wave_buffer_type_si16 = 0,
	zzub_wave_buffer_type_f32 = 1,
	zzub_wave_buffer_type_si32 = 2,
	zzub_wave_buffer_type_si24 = 3,
};

enum zzub_oscillator_type {
	zzub_oscillator_type_sine = 0,
	zzub_oscillator_type_sawtooth = 1,
	zzub_oscillator_type_pulse = 2,
	zzub_oscillator_type_triangle = 3,
	zzub_oscillator_type_noise = 4,
	zzub_oscillator_type_sawtooth_303 = 5,
};

enum zzub_note_value {
	zzub_note_value_none = 0,
	zzub_note_value_off = 255,
	zzub_note_value_cut = 254,
	zzub_note_value_min = 1,
	zzub_note_value_max = 156,
	zzub_note_value_c4 = 65,
};

enum zzub_switch_value {
	zzub_switch_value_none = 255,
	zzub_switch_value_off = 0,
	zzub_switch_value_on = 1,
};

enum zzub_wavetable_index_value {
	zzub_wavetable_index_value_none = 0,
	zzub_wavetable_index_value_min = 1,
	zzub_wavetable_index_value_max = 200,
};

enum zzub_parameter_flag {
	zzub_parameter_flag_wavetable_index = (1 << 0),
	zzub_parameter_flag_state = (1 << 1),
	zzub_parameter_flag_event_on_edit = (1 << 2),
	zzub_parameter_flag_pattern_index = (1 << 3),
	zzub_parameter_flag_velocity_index = (1 << 4),
	zzub_parameter_flag_delay_index = (1 << 5),
	zzub_parameter_flag_compound = (1 << 6),
	zzub_parameter_flag_char_index = (1 << 7),
	zzub_parameter_flag_harmony_index = (1 << 8),
	zzub_parameter_flag_meta_note = (1 << 9),
	zzub_parameter_flag_meta_wave = (1 << 10),
};


/** \brief Plugin flags */
enum zzub_plugin_flag {
	zzub_plugin_flag_plays_waves = (1 << 1),
	zzub_plugin_flag_uses_lib_interface = (1 << 2),
	zzub_plugin_flag_does_input_mixing = (1 << 4),
	zzub_plugin_flag_is_singleton = (1 << 15),
	zzub_plugin_flag_is_root = (1 << 16),
	zzub_plugin_flag_has_audio_input = (1 << 17),
	zzub_plugin_flag_has_audio_output = (1 << 18),
	zzub_plugin_flag_is_offline = (1 << 19),
	zzub_plugin_flag_has_event_output = (1 << 20),
	zzub_plugin_flag_stream = (1 << 22),
	zzub_plugin_flag_has_midi_input = (1 << 23),
	zzub_plugin_flag_has_midi_output = (1 << 24),
	zzub_plugin_flag_is_sequence = (1 << 27),
	zzub_plugin_flag_is_connection = (1 << 28),
	zzub_plugin_flag_is_interval = (1 << 29),
	zzub_plugin_flag_is_encoder = (1 << 30),
	zzub_plugin_flag_has_note_output = (1 << 31),
};

enum zzub_wave_flag {
	zzub_wave_flag_loop = (1 << 0),
	zzub_wave_flag_extended = (1 << 2),
	zzub_wave_flag_stereo = (1 << 3),
	zzub_wave_flag_pingpong = (1 << 4),
	zzub_wave_flag_envelope = (1 << 7),
};

enum zzub_envelope_flag {
	zzub_envelope_flag_sustain = (1 << 0),
	zzub_envelope_flag_loop = (1 << 1),
};

enum zzub_process_mode {
	zzub_process_mode_no_io = 0,
	zzub_process_mode_read = (1 << 0),
	zzub_process_mode_write = (1 << 1),
	zzub_process_mode_read_write = (1 << 0)|(1 << 1),
};

enum zzub_encoder_state {
	zzub_encoder_state_playing = (1 << 0),
	zzub_encoder_state_stopped = (1 << 1),
	zzub_encoder_state_deleted = (1 << 2),
	zzub_encoder_state_seeking = (1 << 3),
	zzub_encoder_state_created = (1 << 4),
};

enum zzub_connection_type {
	zzub_connection_type_audio = 0,
	zzub_connection_type_event = 1,
	zzub_connection_type_midi = 2,
	zzub_connection_type_note = 3,
};

enum zzub_parameter_group {
	zzub_parameter_group_internal = 0,
	zzub_parameter_group_global = 1,
	zzub_parameter_group_track = 2,
	zzub_parameter_group_controller = 3,
	zzub_parameter_group_virtual = 4,
};

enum zzub_validation_error_type {
	zzub_validation_error_type_parameter_count_mismatch = 1,
	zzub_validation_error_type_parameter_type_mismatch = 2,
	zzub_validation_error_type_parameter_flags_mismatch = 3,
	zzub_validation_error_type_parameter_value_min_mismatch = 4,
	zzub_validation_error_type_parameter_value_max_mismatch = 5,
	zzub_validation_error_type_parameter_value_none_mismatch = 6,
	zzub_validation_error_type_parameter_value_default_mismatch = 7,
	zzub_validation_error_type_plugin_not_found_using_dummy = 8,
	zzub_validation_error_type_plugin_validation_failed_using_dummy = 9,
	zzub_validation_error_type_plugin_not_found = 10,
};

int typedef (*zzub_callback_t)(zzub_player_t *player, zzub_plugin_t *plugin, zzub_event_data_t *data, void *tag);
void typedef (*zzub_mix_callback_t)(float *left, float *right, int size, void *tag);
/* class All */

struct zzub_event_data_all {
	zzub_event_data_t *data;
};

/* class DoubleClick */

struct zzub_event_data_double_click {
	zzub_plugin_t *plugin;
};

/* class InsertPlugin */

struct zzub_event_data_insert_plugin {
	zzub_plugin_t *plugin;
};

/* class DeletePlugin */

struct zzub_event_data_delete_plugin {
	zzub_plugin_t *plugin;
};

/* class UpdatePlugin */

struct zzub_event_data_update_plugin {
	zzub_plugin_t *plugin;
};

/* class InsertConnection */

struct zzub_event_data_insert_connection {
	zzub_plugin_t *from_plugin;
	zzub_plugin_t *to_plugin;
	zzub_plugin_t *connection_plugin;
	int type;
};

/* class UpdateConnection */

struct zzub_event_data_update_connection {
	zzub_plugin_t *connection_plugin;
	zzub_plugin_t *from_plugin;
	zzub_plugin_t *to_plugin;
	int type;
};

/* class DeleteConnection */

struct zzub_event_data_delete_connection {
	zzub_plugin_t *connection_plugin;
	zzub_plugin_t *from_plugin;
	zzub_plugin_t *to_plugin;
	int type;
};

/* class InsertPattern */

struct zzub_event_data_insert_pattern {
	zzub_pattern_t *pattern;
};

/* class UpdatePattern */

struct zzub_event_data_update_pattern {
	zzub_pattern_t *pattern;
};

/* class DeletePattern */

struct zzub_event_data_delete_pattern {
	zzub_pattern_t *pattern;
};

/* class InsertPatternEvent */

struct zzub_event_data_insert_pattern_event {
	zzub_pattern_event_t *patternevent;
};

/* class UpdatePatternEvent */

struct zzub_event_data_update_pattern_event {
	zzub_pattern_event_t *patternevent;
};

/* class DeletePatternEvent */

struct zzub_event_data_delete_pattern_event {
	zzub_pattern_event_t *patternevent;
};

/* class InsertPatternFormat */

struct zzub_event_data_insert_pattern_format {
	zzub_pattern_format_t *patternformat;
};

/* class UpdatePatternFormat */

struct zzub_event_data_update_pattern_format {
	zzub_pattern_format_t *patternformat;
};

/* class DeletePatternFormat */

struct zzub_event_data_delete_pattern_format {
	zzub_pattern_format_t *patternformat;
};

/* class InsertPatternFormatColumn */

struct zzub_event_data_insert_pattern_format_column {
	zzub_pattern_format_column_t *patternformatcolumn;
};

/* class UpdatePatternFormatColumn */

struct zzub_event_data_update_pattern_format_column {
	zzub_pattern_format_column_t *patternformatcolumn;
};

/* class DeletePatternFormatColumn */

struct zzub_event_data_delete_pattern_format_column {
	zzub_pattern_format_column_t *patternformatcolumn;
};

/* class MidiMessage */

struct zzub_event_data_midi_message {
	unsigned char status;
	unsigned char data1;
	unsigned char data2;
};

/* class UpdatePluginParameter */

struct zzub_event_data_update_plugin_parameter {
	zzub_plugin_t *plugin;
	int group;
	int track;
	int param;
	int value;
};

/* class PlayerStateChanged */

struct zzub_event_data_player_state_changed {
	int player_state;
};

/* class PlayerOrderChanged */

struct zzub_event_data_player_order_changed {
	int orderindex;
};

/* class Vu */

struct zzub_event_data_vu {
	int size;
	float left_amp;
	float right_amp;
	float time;
};

/* class Serialize */

struct zzub_event_data_serialize {
	char mode;
	zzub_archive_t *archive;
};

/* class Unknown */

struct zzub_event_data_unknown {
	void *param;
};

/* class OscMessage */

struct zzub_event_data_osc_message {
	const char *path;
	const char *types;
	const void * *argv;
	int argc;
	void *msg;
};

/* class InsertWave */

struct zzub_event_data_insert_wave {
	zzub_wave_t *wave;
};

/* class UpdateWave */

struct zzub_event_data_update_wave {
	zzub_wave_t *wave;
};

/* class DeleteWave */

struct zzub_event_data_delete_wave {
	zzub_wave_t *wave;
};

/* class InsertWavelevel */

struct zzub_event_data_insert_wavelevel {
	zzub_wavelevel_t *wavelevel;
};

/* class UpdateWavelevel */

struct zzub_event_data_update_wavelevel {
	zzub_wavelevel_t *wavelevel;
};

/* class UpdateWavelevelSamples */

struct zzub_event_data_update_wavelevel_samples {
	zzub_wavelevel_t *wavelevel;
};

/* class DeleteWavelevel */

struct zzub_event_data_delete_wavelevel {
	zzub_wavelevel_t *wavelevel;
};

/* class Custom */

struct zzub_event_data_custom {
	int id;
	void *data;
};

/* class UserAlert */

struct zzub_event_data_user_alert {
	int type;
	union {
	zzub_plugincollection_t *collection;
	zzub_pluginloader_t *plugin;
	zzub_wave_t *wave;
	int progress;
	};
};

/* class EventData */

struct zzub_event_data {
	int type;
	void *userdata;
	union {
	zzub_event_data_double_click_t double_click;
	zzub_event_data_midi_message_t midi_message;
	zzub_event_data_player_state_changed_t player_state_changed;
	zzub_event_data_player_order_changed_t player_order_changed;
	zzub_event_data_osc_message_t osc_message;
	zzub_event_data_vu_t vu;
	zzub_event_data_serialize_t serialize;
	zzub_event_data_insert_plugin_t insert_plugin;
	zzub_event_data_update_plugin_t update_plugin;
	zzub_event_data_delete_plugin_t delete_plugin;
	zzub_event_data_update_plugin_parameter_t update_pluginparameter;
	zzub_event_data_insert_connection_t insert_connection;
	zzub_event_data_update_connection_t update_connection;
	zzub_event_data_delete_connection_t delete_connection;
	zzub_event_data_insert_pattern_t insert_pattern;
	zzub_event_data_update_pattern_t update_pattern;
	zzub_event_data_delete_pattern_t delete_pattern;
	zzub_event_data_insert_pattern_event_t insert_patternevent;
	zzub_event_data_update_pattern_event_t update_patternevent;
	zzub_event_data_delete_pattern_event_t delete_patternevent;
	zzub_event_data_insert_pattern_format_t insert_pattern_format;
	zzub_event_data_update_pattern_format_t update_pattern_format;
	zzub_event_data_delete_pattern_format_t delete_pattern_format;
	zzub_event_data_insert_pattern_format_column_t insert_pattern_format_column;
	zzub_event_data_update_pattern_format_column_t update_pattern_format_column;
	zzub_event_data_delete_pattern_format_column_t delete_pattern_format_column;
	zzub_event_data_insert_wave_t insert_wave;
	zzub_event_data_update_wave_t update_wave;
	zzub_event_data_delete_wave_t delete_wave;
	zzub_event_data_insert_wavelevel_t insert_wavelevel;
	zzub_event_data_update_wavelevel_t update_wavelevel;
	zzub_event_data_delete_wavelevel_t delete_wavelevel;
	zzub_event_data_update_wavelevel_samples_t update_wavelevel_samples;
	zzub_event_data_user_alert_t alert;
	zzub_event_data_custom_t custom;
	zzub_event_data_all_t all;
	zzub_event_data_unknown_t unknown;
	};
};

/* class Audiodriver */


/** \brief Methods for enumerating, configuring and creating an audio driver instance.
	Implements both the RtAudio and PortAudio APIs. */

/** \brief Create an audio driver that uses the PortAudio API. */
zzub_audiodriver_t *zzub_audiodriver_create_portaudio(zzub_player_t *player);

/** \brief Create an audio driver that uses the RtAudio API. */
zzub_audiodriver_t *zzub_audiodriver_create_rtaudio(zzub_player_t *player);

/** \brief Create a silent, non-processing audio driver that has one device with the specified properties. */
zzub_audiodriver_t *zzub_audiodriver_create_silent(zzub_player_t *player, const char *name, int out_channels, int in_channels, int *supported_rates, int num_rates);

/** \brief Creates the preferred audio driver. */
zzub_audiodriver_t *zzub_audiodriver_create(zzub_player_t *player);

/** \brief Get number of detected input and output audio devices */
int zzub_audiodriver_get_count(zzub_audiodriver_t *audiodriver);

/** \brief Get name of specified audio device */
int zzub_audiodriver_get_name(zzub_audiodriver_t *audiodriver, int index, char *name, int max_len/*=1024*/);

/** \brief Returns an array of supported sample rates as reported by the driver. */
int zzub_audiodriver_get_supported_samplerates(zzub_audiodriver_t *audiodriver, int index, int *result, int maxrates);

/** \brief Returns the number of supported output channels as reported by the driver. */
int zzub_audiodriver_get_supported_output_channels(zzub_audiodriver_t *audiodriver, int index);

/** \brief Returns the number of supported input channels as reported by the driver. */
int zzub_audiodriver_get_supported_input_channels(zzub_audiodriver_t *audiodriver, int index);

/** \brief Returns true if the device is an output device. */
/*bool*/ int zzub_audiodriver_is_output(zzub_audiodriver_t *audiodriver, int index);

/** \brief Returns true if the device is an input device. */
/*bool*/ int zzub_audiodriver_is_input(zzub_audiodriver_t *audiodriver, int index);

/** \brief Create specified audio device. Audio device is disabled by default. */
int zzub_audiodriver_create_device(zzub_audiodriver_t *audiodriver, int input_index, int output_index);

/** \brief Enable or disable current audio driver */
void zzub_audiodriver_enable(zzub_audiodriver_t *audiodriver, int state);

/** \brief Returns whether current audio driver is enabled or disabled */
/*bool*/ int zzub_audiodriver_get_enabled(zzub_audiodriver_t *audiodriver);

/** \brief Disassociate audio driver and player */
void zzub_audiodriver_destroy(zzub_audiodriver_t *audiodriver);

/** \brief De-allocate the current device. */
void zzub_audiodriver_destroy_device(zzub_audiodriver_t *audiodriver);

/** \brief Configuration: Set audio driver sample rate */
void zzub_audiodriver_set_samplerate(zzub_audiodriver_t *audiodriver, unsigned int samplerate);

/** \brief Configuration: Retreive audio driver sample rate */
unsigned int zzub_audiodriver_get_samplerate(zzub_audiodriver_t *audiodriver);

/** \brief Configuration: Set desired audio driver buffer size/latency in samples */
void zzub_audiodriver_set_buffersize(zzub_audiodriver_t *audiodriver, unsigned int buffersize);

/** \brief Configuration: Retreive buffer size/latency */
unsigned int zzub_audiodriver_get_buffersize(zzub_audiodriver_t *audiodriver);

/** \brief Returns CPU load of the audio drivers callback. */
double zzub_audiodriver_get_cpu_load(zzub_audiodriver_t *audiodriver);

/** \brief Configuration: The audio device channel on which the Master plugin sends it output. Usually 0, but can be greater for audio devices that support more than two output channels. */
int zzub_audiodriver_get_master_channel(zzub_audiodriver_t *audiodriver);

/** \brief Configuration: The audio device channel on which the Master plugin sends it output. Usually 0, but can be greater for audio devices that support more than two output channels. */
void zzub_audiodriver_set_master_channel(zzub_audiodriver_t *audiodriver, int index);

/* class Mididriver */


/** \brief Methods for enumerating and opening MIDI input and output devices. */

/** \brief Returns the number of detected input and output MIDI devices. */
int zzub_mididriver_get_count(zzub_player_t *player);

/** \brief Returns the name of a MIDI device. */
const char *zzub_mididriver_get_name(zzub_player_t *player, int index);

/** \brief Returns true if the device is an input device. */
/*bool*/ int zzub_mididriver_is_input(zzub_player_t *player, int index);

/** \brief Returns true if the device is an output device. */
/*bool*/ int zzub_mididriver_is_output(zzub_player_t *player, int index);

/** \brief Opens the MIDI device. */
int zzub_mididriver_open(zzub_player_t *player, int index);

/** \brief Closes all MIDI devices. */
int zzub_mididriver_close_all(zzub_player_t *player);

/* class Plugincollection */


/** \brief For enumerating and configuring plugin collections. */
zzub_plugincollection_t *zzub_plugincollection_get_by_uri(zzub_player_t *player, const char *uri);

/** \brief Returns the name of the plugin collection. E.g 'VST' for the VST wrapper. */
const char *zzub_plugincollection_get_name(zzub_plugincollection_t *plugincollection);

/** \brief Passes a key/value-pair to the plugin collection. Used to set e.g VST scanning paths. */
void zzub_plugincollection_configure(zzub_plugincollection_t *plugincollection, const char *key, const char *value);

/* class Input */


/** \brief Methods for working with file- or memory-based input streams. E.g reading from a file or buffer. */

/** \brief Create an input stream that reads from a file. */
zzub_input_t *zzub_input_open_file(const char *filename);

/** \brief Closes an input stream created with zzub_create_output_XXX. */
void zzub_input_destroy(zzub_input_t *input);

/** \brief Reads bytes from the stream. */
int zzub_input_read(zzub_input_t *input, char *buffer, int bytes);

/** \brief Returns the total number of bytes that can be read from the stream. */
int zzub_input_size(zzub_input_t *input);

/** \brief Returns the current read position in the stream. */
int zzub_input_position(zzub_input_t *input);

/** \brief Seeks to a specified offset in the stream. */
void zzub_input_seek(zzub_input_t *input, int pos, int mode);

/* class Output */


/** \brief Methods for working with file- or memory-based output streams. E.g writing to a file or buffer. */

/** \brief Create an output stream that writes to a file. */
zzub_output_t *zzub_output_create_file(const char *filename);

/** \brief Closes an output stream created with zzub_create_output_XXX. */
void zzub_output_destroy(zzub_output_t *output);

/** \brief Writes bytes to the stream. */
void zzub_output_write(zzub_output_t *output, const char *buffer, int bytes);

/** \brief Returns the current write position in the stream. */
int zzub_output_position(zzub_output_t *output);

/** \brief Seeks to a specified offset in the stream. */
void zzub_output_seek(zzub_output_t *output, int pos, int mode);

/* class Archive */


/** \brief Methods for working with in-memory streams. */

/** \brief Create an in-memory archive of keyed input and output streams. */
zzub_archive_t *zzub_archive_create_memory();

/** \brief Returns an output stream object for writing. */
zzub_output_t *zzub_archive_get_output(zzub_archive_t *archive, const char *path);

/** \brief Returns an input stream object for reading. */
zzub_input_t *zzub_archive_get_input(zzub_archive_t *archive, const char *path);

/** \brief Destroys the archive and frees allocated resources. */
void zzub_archive_destroy(zzub_archive_t *archive);

/* class Midimapping */


/** \brief Represents a binding between a MIDI controller and a plugin parameter.
	To create a MIDI mapping, see zzub_player_add_midimapping(). */

/** \brief Bound plugin. */
int zzub_midimapping_get_plugin(zzub_midimapping_t *midimapping);

/** \brief Bound plugin group. */
int zzub_midimapping_get_group(zzub_midimapping_t *midimapping);

/** \brief Bound plugin track. */
int zzub_midimapping_get_track(zzub_midimapping_t *midimapping);

/** \brief Bound plugin column. */
int zzub_midimapping_get_column(zzub_midimapping_t *midimapping);

/** \brief Bound MIDI channel. */
int zzub_midimapping_get_channel(zzub_midimapping_t *midimapping);

/** \brief Bound MIDI controller. */
int zzub_midimapping_get_controller(zzub_midimapping_t *midimapping);

/* class PatternEvent */


/** \brief Represents an event in a pattern. */

/** \brief Event ID. */
int zzub_pattern_event_get_id(zzub_pattern_event_t *patternevent);

/** \brief Event plugin id. */
int zzub_pattern_event_get_pluginid(zzub_pattern_event_t *patternevent);

/** \brief Returns the pattern in which the event occurs. */
zzub_pattern_t *zzub_pattern_event_get_pattern(zzub_pattern_event_t *patternevent);

/** \brief Event plugin group. */
int zzub_pattern_event_get_group(zzub_pattern_event_t *patternevent);

/** \brief Event plugin track. */
int zzub_pattern_event_get_track(zzub_pattern_event_t *patternevent);

/** \brief Event plugin column. */
int zzub_pattern_event_get_column(zzub_pattern_event_t *patternevent);

/** \brief Event timestamp. The unit of the timestamp depends on the context in which the pattern is being played. */
int zzub_pattern_event_get_time(zzub_pattern_event_t *patternevent);

/** \brief Returns the event value. */
int zzub_pattern_event_get_value(zzub_pattern_event_t *patternevent);

/** \brief Returns the events meta value. Used with notes. */
int zzub_pattern_event_get_meta(zzub_pattern_event_t *patternevent);

/** \brief Set a new value on this event. */
int zzub_pattern_event_set_value(zzub_pattern_event_t *patternevent, int value);

/** \brief Set a new meta value on this event. */
int zzub_pattern_event_set_meta(zzub_pattern_event_t *patternevent, int meta);

/** \brief Set a new timestamp on this event. */
int zzub_pattern_event_set_time(zzub_pattern_event_t *patternevent, int value);

/* class PatternIterator */


/** \brief Helper iterator for a range of patterns. */

/** \brief Iterates to the next item. */
void zzub_pattern_iterator_next(zzub_pattern_iterator_t *patterniterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_pattern_iterator_valid(zzub_pattern_iterator_t *patterniterator);

/** \brief Returns the current item. */
zzub_pattern_t *zzub_pattern_iterator_current(zzub_pattern_iterator_t *patterniterator);

/** \brief Destroys the iterator. */
void zzub_pattern_iterator_destroy(zzub_pattern_iterator_t *patterniterator);

/* class PatternEventIterator */


/** \brief Helper iterator for a range of pattern events. */

/** \brief Iterates to the next item. */
void zzub_pattern_event_iterator_next(zzub_pattern_event_iterator_t *patterneventiterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_pattern_event_iterator_valid(zzub_pattern_event_iterator_t *patterneventiterator);

/** \brief Returns the current item. */
zzub_pattern_event_t *zzub_pattern_event_iterator_current(zzub_pattern_event_iterator_t *patterneventiterator);

/** \brief Destroys the iterator. */
void zzub_pattern_event_iterator_destroy(zzub_pattern_event_iterator_t *patterneventiterator);

/* class Pattern */


/** \brief Methods for working with a pattern.
	The format of a pattern is completely dynamic, defined by a zzub_pattern_format.
	To create a new pattern, see zzub_player_create_pattern(). */

/** \brief Destroys the pattern and frees all resources. */
void zzub_pattern_destroy(zzub_pattern_t *pattern);

/** \brief Returns the pattern name. */
void zzub_pattern_get_name(zzub_pattern_t *pattern, char *name, int maxLen/*=1024*/);

/** \brief Set the pattern name. */
void zzub_pattern_set_name(zzub_pattern_t *pattern, const char *name);

/** \brief Returns length of pattern. */
int zzub_pattern_get_row_count(zzub_pattern_t *pattern);

/** \brief Sets length of pattern. */
void zzub_pattern_set_row_count(zzub_pattern_t *pattern, int length);

/** \brief Pattern ID. */
int zzub_pattern_get_id(zzub_pattern_t *pattern);

/** \brief Returns the pattern format. */
zzub_pattern_format_t *zzub_pattern_get_format(zzub_pattern_t *pattern);

/** \brief Sets the pattern format. */
void zzub_pattern_set_format(zzub_pattern_t *pattern, zzub_pattern_format_t *format);

/** \brief Returns the pattern resolution - rows per tick. */
int zzub_pattern_get_resolution(zzub_pattern_t *pattern);

/** \brief Sets the pattern resolution. */
void zzub_pattern_set_resolution(zzub_pattern_t *pattern, int resolution);

/** \brief Display resolution. Has no effect on the audio output. */
int zzub_pattern_get_display_resolution(zzub_pattern_t *pattern);

/** \brief Display resolution. Has no effect on the audio output. */
void zzub_pattern_set_display_resolution(zzub_pattern_t *pattern, int resolution);

/** \brief Display beat coloring. Has no effect on the audio output. */
void zzub_pattern_get_display_beat_rows(zzub_pattern_t *pattern, int *verydarkrow, int *darkrow);

/** \brief Display beat coloring. Has no effect on the audio output. */
void zzub_pattern_set_display_beat_rows(zzub_pattern_t *pattern, int verydarkrow, int darkrow);

/** \brief Returns where the pattern starts looping. */
int zzub_pattern_get_loop_start(zzub_pattern_t *pattern);

/** \brief Sets where the pattern starts looping. */
void zzub_pattern_set_loop_start(zzub_pattern_t *pattern, int pos);

/** \brief Returns where the pattern ends looping. */
int zzub_pattern_get_loop_end(zzub_pattern_t *pattern);

/** \brief Sets where the pattern ends looping. */
void zzub_pattern_set_loop_end(zzub_pattern_t *pattern, int pos);

/** \brief Returns whether pattern looping is enabled. */
int zzub_pattern_get_loop_enabled(zzub_pattern_t *pattern);

/** \brief Sets whether pattern looping is enabled. */
void zzub_pattern_set_loop_enabled(zzub_pattern_t *pattern, int enable);

/** \brief Returns the position from where pattern replay starts. */
int zzub_pattern_get_replay_row(zzub_pattern_t *pattern);

/** \brief Sets the position from where pattern replay starts. */
void zzub_pattern_set_replay_row(zzub_pattern_t *pattern, int row);

/** \brief Retreive the currently playing row for a pattern. */
int zzub_pattern_get_currently_playing_row(zzub_pattern_t *pattern, int *row);

/** \brief Sets the value of a pattern event.
	This checks for the existence of an existing event at the specified timestamp, and updates the value if it exists. For a faster version, see zzub_pattern_insert_value(). */
void zzub_pattern_set_value(zzub_pattern_t *pattern, int row, zzub_plugin_t *plugin, int group, int track, int column, int value, int meta);

/** \brief Returns the value of a pattern event. */
int zzub_pattern_get_value(zzub_pattern_t *pattern, int row, int pluginid, int group, int track, int column, int *value, int *meta);

/** \brief Returns an iterator for iterating over pattern events. Pass NULL for the plugin parameter to retreive all events. -1 can be sent to group, track and column to return only a selected group/track/column. */
zzub_pattern_event_iterator_t *zzub_pattern_get_event_iterator(zzub_pattern_t *pattern, zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Like get_event_iterator, but not sorted by time. Performs faster. */
zzub_pattern_event_iterator_t *zzub_pattern_get_event_unsorted_iterator(zzub_pattern_t *pattern, zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Inserts a value into the pattern without checking if an event already exists. This should only be used for new patterns: the behavior of multiple events at the same timestamp is undefined. */
void zzub_pattern_insert_value(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int time, int value, int meta);

/** \brief Deletes an event from the pattern. */
void zzub_pattern_delete_value(zzub_pattern_t *pattern, int id);

/** \brief Changes the time stamp and values of an event. */
void zzub_pattern_update_value(zzub_pattern_t *pattern, int id, int time, int value, int meta);

/** \brief Changes the parameter, time stamp and values of an event. */
void zzub_pattern_update_value_full(zzub_pattern_t *pattern, int id, int pluginid, int group, int track, int column, int time, int value, int meta);

/** \brief Transform: Compact pattern by a factor. */
void zzub_pattern_compact_pattern(zzub_pattern_t *pattern, int factor);

/** \brief Transform: Expand pattern by a factor. */
void zzub_pattern_expand_pattern(zzub_pattern_t *pattern, int factor);

/** \brief Transform: Shift events by time. */
void zzub_pattern_timeshift_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int timeshift);

/** \brief Transform: Delete events. */
void zzub_pattern_delete_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_move_scale_events(zzub_pattern_t *pattern, int src_idx, int src_time, int dst_idx, int dst_time, int width, int length, int mode, int makecopy);

/** \brief Accepts a stream of pattern events and pastes them at a location in the pattern. All parameter ranges will be scaled. */
void zzub_pattern_paste_stream_events(zzub_pattern_t *pattern, int fromidx, int fromtime, int mode, const char *charbuf);

/** \brief Transform. */
void zzub_pattern_transpose_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int delta, int *holes, int holecount, int *metas, int metacount, int chromatic);

/** \brief Transform. */
void zzub_pattern_randomize_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int skip);

/** \brief Transform. */
void zzub_pattern_randomize_range_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int from_val, int to_val, int skip);

/** \brief Transform. */
void zzub_pattern_randomize_from_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int skip);

/** \brief Transform. */
void zzub_pattern_humanize_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int deviation);

/** \brief Transform. */
void zzub_pattern_shuffle_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_interpolate_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int skip);

/** \brief Transform. */
void zzub_pattern_gradiate_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int skip);

/** \brief Transform. */
void zzub_pattern_smooth_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int strength);

/** \brief Transform. */
void zzub_pattern_reverse_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_compact_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int factor);

/** \brief Transform. */
void zzub_pattern_expand_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int factor);

/** \brief Transform. */
void zzub_pattern_thin_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int major);

/** \brief Transform. */
void zzub_pattern_repeat_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int major);

/** \brief Transform. */
void zzub_pattern_echo_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int major);

/** \brief Transform. */
void zzub_pattern_unique_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_scale_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, double min1, double max1, double min2, double max2);

/** \brief Transform. */
void zzub_pattern_fade_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, double from, double to);

/** \brief Transform. */
void zzub_pattern_curvemap_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int mode);

/** \brief Transform. */
void zzub_pattern_invert_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_rotate_rows_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int offset);

/** \brief Transform. */
void zzub_pattern_rotate_vals_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int offset);

/** \brief Transform. */
void zzub_pattern_rotate_dist_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int offset);

/** \brief Transform. */
void zzub_pattern_set_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int value, int meta);

/** \brief Transform. */
void zzub_pattern_replace_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int from_value, int from_meta, int to_value, int to_meta);

/** \brief Transform. */
void zzub_pattern_remove_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int value, int meta);

/** \brief Transform. */
void zzub_pattern_notelength_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int fromtime, int length, int desired_len, int mode, int off_value);

/** \brief Transform. */
void zzub_pattern_volumes_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int note_column, int vol_column, int fromtime, int length, int mode);

/** \brief Transform. */
void zzub_pattern_swap_track_events(zzub_pattern_t *pattern, int left_idx, int right_idx, int fromtime, int length);

/** \brief Transform. */
void zzub_pattern_swap_rows_events(zzub_pattern_t *pattern, int pluginid, int group, int track, int column, int top_row, int bottom_row);

/** \brief Transform. */
void zzub_pattern_invert_chord_events(zzub_pattern_t *pattern, int left_idx, int right_idx, int fromtime, int length, int direction, int mode);

/** \brief Edits notes independently of voice.
	mode 0 = move entire notes, mode 1 = move beginning of notes, mode 2 = move end of notes */
void zzub_pattern_move_and_transpose_notes(zzub_pattern_t *pattern, const zzub_pattern_event_t * *events, int numevents, int timeshift, int pitchshift, int mode);

/** \brief Inserts a voice-independent note. */
void zzub_pattern_insert_note(zzub_pattern_t *pattern, zzub_plugin_t *plugin, int time, int note, int length);

/** \brief Updates a voice-independent note. */
void zzub_pattern_update_note(zzub_pattern_t *pattern, zzub_pattern_event_t *event, int time, int note, int length);

/* class PatternFormat */


/** \brief Container class for which columns to refer in a pattern.
	To create a new pattern format, see zzub_player_create_pattern_format().
	@SEEALSO: Pattern, PatternFormatIterator, PatternFormatColumn, PatternFormatColumnIterator */

/** \brief Adds a column to the pattern format. */
void zzub_pattern_format_add_column(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column, int idx);

/** \brief Removes a column from the pattern format. */
void zzub_pattern_format_delete_column(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Returns an iterator over the columns in the pattern format. */
zzub_pattern_format_column_iterator_t *zzub_pattern_format_get_iterator(zzub_pattern_format_t *patternformat);

/** \brief Returns the pattern format column for a specified parameter. */
zzub_pattern_format_column_t *zzub_pattern_format_get_column(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Returns the pattern format name. */
int zzub_pattern_format_get_name(zzub_pattern_format_t *patternformat, char *name, int maxlen/*=1024*/);

/** \brief Sets the pattern format name. */
void zzub_pattern_format_set_name(zzub_pattern_format_t *patternformat, const char *name);

/** \brief Pattern format ID. */
int zzub_pattern_format_get_id(zzub_pattern_format_t *patternformat);

/** \brief Sets the name of a pattern format track. */
void zzub_pattern_format_set_track_name(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, const char *name);

/** \brief Returns the name of a pattern format track. */
int zzub_pattern_format_get_track_name(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, char *name, int maxlen/*=1024*/);

/** \brief Sets the mute state for a pattern format track. Causes pattern events on this track to be ignored during playback. */
void zzub_pattern_format_set_track_mute(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int state);

/** \brief Returns the mute state for a pattern format track. */
int zzub_pattern_format_get_track_mute(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track);

/** \brief Unused. */
void zzub_pattern_format_add_column_filter(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column, zzub_pattern_format_t *filterformat);

/** \brief Unused. */
void zzub_pattern_format_remove_column_filter(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column, zzub_pattern_format_t *filterformat);

/** \brief Unused. */
zzub_pattern_format_iterator_t *zzub_pattern_format_get_column_filters(zzub_pattern_format_t *patternformat, zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Returns the display width of the pattern preview scroller. */
int zzub_pattern_format_get_scroller_width(zzub_pattern_format_t *patternformat);

/** \brief Sets the display width of the pattern preview scroller. */
void zzub_pattern_format_set_scroller_width(zzub_pattern_format_t *patternformat, int width);

/** \brief Destroys the pattern format and releases allocated resources. */
void zzub_pattern_format_destroy(zzub_pattern_format_t *patternformat);

/* class PatternFormatIterator */


/** \brief Helper iterator for a range of pattern formats. */

/** \brief Iterates to the next item. */
void zzub_pattern_format_iterator_next(zzub_pattern_format_iterator_t *patternformatiterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_pattern_format_iterator_valid(zzub_pattern_format_iterator_t *patternformatiterator);

/** \brief Returns the current item. */
zzub_pattern_format_t *zzub_pattern_format_iterator_current(zzub_pattern_format_iterator_t *patternformatiterator);

/** \brief Destroys the iterator. */
void zzub_pattern_format_iterator_destroy(zzub_pattern_format_iterator_t *patternformatiterator);

/* class PatternFormatColumn */


/** \brief Represents a column in a pattern. */

/** \brief Plugin referenced by this column. */
zzub_plugin_t *zzub_pattern_format_column_get_plugin(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Plugin group referenced by this column. */
int zzub_pattern_format_column_get_group(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Plugin track referenced by this column. */
int zzub_pattern_format_column_get_track(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Plugin column referenced by this column. */
int zzub_pattern_format_column_get_column(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Returns the pattern format where the column is referenced. */
zzub_pattern_format_t *zzub_pattern_format_column_get_format(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Return column rendering mode.
	mode 0: default, 1: note, 2: switch, 3: byte, 4: word, 5: slider, 6: button, 7: pianoroll, 8: pattern, 9: collapsed, 10: envelope, 11: character, 12: harmonic */
int zzub_pattern_format_column_get_mode(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Set column rendering mode.
	mode 0: default, 1: note, 2: switch, 3: byte, 4: word, 5: slider, 6: button, 7: pianoroll, 8: pattern, 9: collapsed, 10: envelope, 11: character, 12: harmonic */
void zzub_pattern_format_column_set_mode(zzub_pattern_format_column_t *patternformatcolumn, int mode);

/** \brief Returns true if column is visually collapsed. */
int zzub_pattern_format_column_get_collapsed(zzub_pattern_format_column_t *patternformatcolumn);

/** \brief Set whether column is visually collapsed. */
void zzub_pattern_format_column_set_collapsed(zzub_pattern_format_column_t *patternformatcolumn, int is_collapsed);
int zzub_pattern_format_column_get_index(zzub_pattern_format_column_t *patternformatcolumn);
void zzub_pattern_format_column_set_index(zzub_pattern_format_column_t *patternformatcolumn, int idx);

/* class PatternFormatColumnIterator */


/** \brief Helper iterator for a range of pattern format columns. */

/** \brief Iterates to the next item. */
void zzub_pattern_format_column_iterator_next(zzub_pattern_format_column_iterator_t *patternformatcolumniterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_pattern_format_column_iterator_valid(zzub_pattern_format_column_iterator_t *patternformatcolumniterator);

/** \brief Returns the current item. */
zzub_pattern_format_column_t *zzub_pattern_format_column_iterator_current(zzub_pattern_format_column_iterator_t *patternformatcolumniterator);

/** \brief Destroys the iterator. */
void zzub_pattern_format_column_iterator_destroy(zzub_pattern_format_column_iterator_t *patternformatcolumniterator);

/* class Parameter */


/** \brief Represents a plugin parameter. */

/** \brief Returns one of the values in the zzub_parameter_type enumeration. */
int zzub_parameter_get_type(zzub_parameter_t *parameter);

/** \brief The parameter name. */
const char *zzub_parameter_get_name(zzub_parameter_t *parameter);

/** \brief Parameter description. */
const char *zzub_parameter_get_description(zzub_parameter_t *parameter);

/** \brief Parameter minimum value. */
int zzub_parameter_get_value_min(zzub_parameter_t *parameter);

/** \brief Parameter maximum value. */
int zzub_parameter_get_value_max(zzub_parameter_t *parameter);

/** \brief Parameter novalue, a value to indicate there is no value. */
int zzub_parameter_get_value_none(zzub_parameter_t *parameter);

/** \brief Parameter default value. */
int zzub_parameter_get_value_default(zzub_parameter_t *parameter);

/** \brief A parameter flag is combined by zero or more values in the zzub_parameter_flag enumeration. */
int zzub_parameter_get_flags(zzub_parameter_t *parameter);

/* class Attribute */


/** \brief Represents a plugin attribute.
	Attributes are similar to plugin parameters, but they cannot be automated. */

/** \brief Attribute name. */
const char *zzub_attribute_get_name(zzub_attribute_t *attribute);

/** \brief Attribute minimum value. */
int zzub_attribute_get_value_min(zzub_attribute_t *attribute);

/** \brief Attribute maximum value. */
int zzub_attribute_get_value_max(zzub_attribute_t *attribute);

/** \brief Attribute default value. */
int zzub_attribute_get_value_default(zzub_attribute_t *attribute);

/* class Pluginloader */


/** \brief Represents the description of a plugin type.
	Provides access to static properties of a plugin, such as parameter descriptions, attributes, tracks and channel descriptions. */

/** \brief Returns the name of the plugin type. */
const char *zzub_pluginloader_get_name(zzub_pluginloader_t *pluginloader);

/** \brief Returns the short name of the plugin. Used to generate names for new instances of this plugin type. */
const char *zzub_pluginloader_get_short_name(zzub_pluginloader_t *pluginloader);

/** \brief Returns number of parameters. Group 1 = global parameters, group 2 = track parameters, group 3 = event parameters */
int zzub_pluginloader_get_parameter_count(zzub_pluginloader_t *pluginloader, int group);

/** \brief Returns the parameter for a group and column. See also zzub_plugin_get_parameter() which also returns parameters in group 0. */
zzub_parameter_t *zzub_pluginloader_get_parameter(zzub_pluginloader_t *pluginloader, int group, int index);

/** \brief Returns the number of attributes. */
int zzub_pluginloader_get_attribute_count(zzub_pluginloader_t *pluginloader);

/** \brief Returns an attribute. */
zzub_attribute_t *zzub_pluginloader_get_attribute(zzub_pluginloader_t *pluginloader, int index);

/** \brief Returns the flags for this plugin loader. Combined by zero or more values in the zzub_plugin_flag enumeration. */
int zzub_pluginloader_get_flags(zzub_pluginloader_t *pluginloader);

/** \brief Returns a string uniquely identifying this plugin type. */
const char *zzub_pluginloader_get_uri(zzub_pluginloader_t *pluginloader);

/** \brief Returns the name of the plugin author. */
const char *zzub_pluginloader_get_author(zzub_pluginloader_t *pluginloader);

/** \brief Returns a list of plugin-defined instruments. */
int zzub_pluginloader_get_instrument_list(zzub_pluginloader_t *pluginloader, char *result, int maxbytes);

/** \brief Returns the minimum number of tracks. */
int zzub_pluginloader_get_tracks_min(zzub_pluginloader_t *pluginloader);

/** \brief Returns the maximum number of tracks. */
int zzub_pluginloader_get_tracks_max(zzub_pluginloader_t *pluginloader);

/** \brief Returns the number of supported stream formats. Used with plugins flagged zzub_plugin_flag_stream. */
int zzub_pluginloader_get_stream_format_count(zzub_pluginloader_t *pluginloader);

/** \brief Returns a supported stream file format extension stream. Used with plugins flagged zzub_plugin_flag_stream. */
const char *zzub_pluginloader_get_stream_format_ext(zzub_pluginloader_t *pluginloader, int index);

/** \brief Returns the maximum number of output audio channels the plugin intends to use. */
int zzub_pluginloader_get_output_channel_count(zzub_pluginloader_t *pluginloader);

/** \brief Returns the maximum number of input audio channels the plugin intends to use. */
int zzub_pluginloader_get_input_channel_count(zzub_pluginloader_t *pluginloader);

/** \brief Returns the full path to the wrapped plugin. Returns blank for built-in plugins. */
const char *zzub_pluginloader_get_plugin_file(zzub_pluginloader_t *pluginloader);

/** \brief Returns the plugin collection where this pluginloader belongs */
zzub_plugincollection_t *zzub_pluginloader_get_plugincollection(zzub_pluginloader_t *pluginloader);

/* class Plugin */


/** \brief Plugin methods
	Retreive more details about plugins. */

/** \brief Deletes a plugin */
int zzub_plugin_destroy(zzub_plugin_t *plugin);

/** \brief Load plugin state. */
int zzub_plugin_load(zzub_plugin_t *plugin, zzub_input_t *input);

/** \brief Save plugin state. */
int zzub_plugin_save(zzub_plugin_t *plugin, zzub_output_t *ouput);

/** \brief Renames a plugin. Should fail and return -1 if the name already exists. */
int zzub_plugin_set_name(zzub_plugin_t *plugin, const char *name);

/** \brief Retreive the name of a plugin. */
int zzub_plugin_get_name(zzub_plugin_t *plugin, char *name, int maxlen/*=1024*/);

/** \brief Retreive the unique per-session id of a plugin. See also zzub_player_get_plugin_by_id(). */
int zzub_plugin_get_id(zzub_plugin_t *plugin);

/** \brief Returns the screen position coordinates for the plugin. Values are expected to be in the range -1..1. */
void zzub_plugin_get_position(zzub_plugin_t *plugin, float *x, float *y);

/** \brief Sets the plugin screen position. Values are expected to be in the range -1..1. */
void zzub_plugin_set_position(zzub_plugin_t *plugin, float x, float y);

/** \brief Sets the plugin screen position. Values are expected to be in the range -1..1. This method is not undoable. */
void zzub_plugin_set_position_direct(zzub_plugin_t *plugin, float x, float y);

/** \brief Returns flags for this plugin. Shorthand for using zzub_pluginloader_get_flags(). Combined by zero or more values in the zzub_plugin_flag enumeration. */
int zzub_plugin_get_flags(zzub_plugin_t *plugin);

/** \brief Returns the number of tracks. */
int zzub_plugin_get_track_count(zzub_plugin_t *plugin, int group);

/** \brief Sets the number of tracks. Will call plugin::set_track_count() from the player thread. */
void zzub_plugin_set_track_count(zzub_plugin_t *plugin, int count);

/** \brief Returns 1 if plugin is muted, otherwise 0. */
int zzub_plugin_get_mute(zzub_plugin_t *plugin);

/** \brief Set whether plugin is muted. 1 for muted, 0 for normal.
	A muted machine does not produce any sound. */
void zzub_plugin_set_mute(zzub_plugin_t *plugin, int muted);

/** \brief Returns 1 if plugin is bypassed, otherwise 0. */
int zzub_plugin_get_bypass(zzub_plugin_t *plugin);

/** \brief Set whether plugin is bypassed. 1 for bypass, 0 for normal.
	Bypass causes no processing to occur in the given machine. */
void zzub_plugin_set_bypass(zzub_plugin_t *plugin, int muted);

/** \brief Returns true if the plugin is (visually) minimized. */
int zzub_plugin_get_minimize(zzub_plugin_t *plugin);

/** \brief Display the plugin as (visually) minimized. */
void zzub_plugin_set_minimize(zzub_plugin_t *plugin, int minimized);

/** \brief Configure a plugin option. this is e.g. used by the recorder plugin to
	specify a file path to write to. */
void zzub_plugin_configure(zzub_plugin_t *plugin, const char *key, const char *value);

/** \brief Returns a string of \\\
-separated command strings */
int zzub_plugin_get_commands(zzub_plugin_t *plugin, char *commands, int maxlen/*=1024*/);

/** \brief When a plugin command string starts with the char '\', it has subcommands.
	Unexpectedly, zzub_plugin_get_sub_commands returns a \\\
-separated string (like get_commands).
	Some plugins need to be ticked before calling get_sub_commands. */
int zzub_plugin_get_sub_commands(zzub_plugin_t *plugin, int i, char *commands, int maxlen/*=1024*/);

/** \brief Invoke a command on the plugin. */
void zzub_plugin_command(zzub_plugin_t *plugin, int i);

/** \brief Returns the pluginloader used to create this plugin. */
zzub_pluginloader_t *zzub_plugin_get_pluginloader(zzub_plugin_t *plugin);

/** \brief Returns the number of virtual MIDI devices implemented by the plugin. */
int zzub_plugin_get_midi_output_device_count(zzub_plugin_t *plugin);

/** \brief Returns the name of a virtual MIDI device. */
const char *zzub_plugin_get_midi_output_device(zzub_plugin_t *plugin, int index);

/** \brief Returns the number of envelopes the plugin supports. */
int zzub_plugin_get_envelope_count(zzub_plugin_t *plugin);

/** \brief Returns envelope flags. */
int zzub_plugin_get_envelope_flags(zzub_plugin_t *plugin, int index);

/** \brief Returns envelope name. */
const char *zzub_plugin_get_envelope_name(zzub_plugin_t *plugin, int index);

/** \brief Sets an audio stream resource identifier.
	E.g a filename, url or wavetable index. Supported by plugins flagged zzub_plugin_flag_stream. */
void zzub_plugin_set_stream_source(zzub_plugin_t *plugin, const char *resource);

/** \brief Returns an audio stream resource identifier.
	E.g a filename, url or wavetable index. Supported by plugins flagged zzub_plugin_flag_stream. */
const char *zzub_plugin_get_stream_source(zzub_plugin_t *plugin);

/** \brief Sets the plugin instrument (d'oh!) */
int zzub_plugin_set_instrument(zzub_plugin_t *plugin, const char *name);

/** \brief Creates a textual description of the given value. The return value is the number of characters in the output string. */
int zzub_plugin_describe_value(zzub_plugin_t *plugin, int group, int column, int value, char *name, int maxlen/*=1024*/);

/** \brief Returns the last written value of the requested parameter. */
int zzub_plugin_get_parameter_value(zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Sets the value of a plugin parameter. The method will wait for the player thread to pick up the modified value and call process_events(). */
void zzub_plugin_set_parameter_value(zzub_plugin_t *plugin, int group, int track, int column, int value, int record);

/** \brief Sets the value of a plugin parameter. Unlike zzub_plugin_set_parameter_value(), this method returns immediately. The parameter will be changed later when the player thread notices the modified value. Is also not undoable. */
void zzub_plugin_set_parameter_value_direct(zzub_plugin_t *plugin, int group, int track, int column, int value, int record);

/** \brief Returns number of parameters in a given plugin group. Shortcut for zzub_pluginloader_get_parameter_count(). */
int zzub_plugin_get_parameter_count(zzub_plugin_t *plugin, int group, int track);

/** \brief Returns a parameter description. */
zzub_parameter_t *zzub_plugin_get_parameter(zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Returns the parameter interpolation mode.
	Mode 0 = absolute, 1 = inertial, 2 = linear */
int zzub_plugin_get_parameter_interpolator(zzub_plugin_t *plugin, int group, int track, int column);

/** \brief Sets the parameter interpolation mode.
	Mode 0 = absolute, 1 = inertial, 2 = linear */
void zzub_plugin_set_parameter_interpolator(zzub_plugin_t *plugin, int group, int track, int column, int mode);

/** \brief Returns the number of input connections for given plugin. */
int zzub_plugin_get_input_connection_count(zzub_plugin_t *plugin);

/** \brief Returns an index-based connection object. */
zzub_connection_t *zzub_plugin_get_input_connection(zzub_plugin_t *plugin, int index);

/** \brief Returns the input connection index for given plugin and connection type. */
zzub_connection_t *zzub_plugin_get_input_connection_by_type(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin, int type);

/** \brief Returns the number of output connections for given plugin. */
int zzub_plugin_get_output_connection_count(zzub_plugin_t *plugin);

/** \brief Returns an index-based connection object. */
zzub_connection_t *zzub_plugin_get_output_connection(zzub_plugin_t *plugin, int index);

/** \brief Returns the output connection index for given plugin and connection type. */
zzub_connection_t *zzub_plugin_get_output_connection_by_type(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin, int type);

/** \brief Connects two audio plugins. Feedback loops permitted.
	Use zzub_connection_destroy() to disconnect. */
zzub_connection_t *zzub_plugin_create_audio_connection(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin, int first_input, int input_count, int first_output, int output_count);

/** \brief Connects two MIDI plugins. Feedback loops not permitted.
	Use zzub_connection_destroy() to disconnect. */
zzub_connection_t *zzub_plugin_create_midi_connection(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin, const char *midi_device);

/** \brief Connects a controller plugin to another plugin.
	Use zzub_connection_add_event_connection_binding() to map parameters. Use zzub_connection_destroy() to disconnect. */
zzub_connection_t *zzub_plugin_create_event_connection(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin);

/** \brief Connects two plugins with note parameters.
	Use zzub_connection_destroy() to disconnect. */
zzub_connection_t *zzub_plugin_create_note_connection(zzub_plugin_t *plugin, zzub_plugin_t *from_plugin);

/** \brief Returns a value from the mixer between 0..1 for right/left to indicate current peak levels. */
void zzub_plugin_get_last_peak(zzub_plugin_t *plugin, float *maxL, float *maxR);

/** \brief Returns a value from the mixer between 0..1 for a current estimated CPU load. */
double zzub_plugin_get_last_cpu_load(zzub_plugin_t *plugin);

/** \brief Returns non-zero if the plugin recently outputted MIDI. */
int zzub_plugin_get_last_midi_result(zzub_plugin_t *plugin);

/** \brief Returns non-zero if the plugin recently outputted audio. */
int zzub_plugin_get_last_audio_result(zzub_plugin_t *plugin);

/** \brief Process changed parameters. immediate == true is only allowed on a plugin after create_plugin() and before the following barrier(). When immediate==false, the plugin will be processed after barrier(). */
void zzub_plugin_tick(zzub_plugin_t *plugin, int immediate);

/** \brief Retreives a plugin attribute value. Refer to zzub_pluginloader_t for attribute counts and descriptions. */
int zzub_plugin_get_attribute_value(zzub_plugin_t *plugin, int index);

/** \brief Sets a plugin attribute value. Refer to zzub_pluginloader_t for attribute counts and descriptions. */
void zzub_plugin_set_attribute_value(zzub_plugin_t *plugin, int index, int value);

/** \brief Plays a note. */
void zzub_plugin_play_midi_note(zzub_plugin_t *plugin, int note, int prevNote, int velocity);

/** \brief Sets the current time source for this plugin. */
void zzub_plugin_set_timesource(zzub_plugin_t *plugin, zzub_plugin_t *timesource, int group, int track);

/** \brief Returns the current time source plugin for this plugin. */
zzub_plugin_t *zzub_plugin_get_timesource_plugin(zzub_plugin_t *plugin);

/** \brief Returns the current time source plugin parameter group for this plugin. */
int zzub_plugin_get_timesource_group(zzub_plugin_t *plugin);

/** \brief Returns the current time source plugin parameter track for this plugin. */
int zzub_plugin_get_timesource_track(zzub_plugin_t *plugin);

/** \brief Returns the actual number of output audio channels the plugin intends to use. */
int zzub_plugin_get_output_channel_count(zzub_plugin_t *plugin);

/** \brief Returns the actual number of input audio channels the plugin intends to use. */
int zzub_plugin_get_input_channel_count(zzub_plugin_t *plugin);

/** \brief Request out-of-graph float data from a plugin. Used by e.g a visualizer plugin to return raw visualizer data to the host for rendering.
	When buffers is NULL, the chunk size is returned. */
int zzub_plugin_get_encoder_digest(zzub_plugin_t *plugin, int type, float * *buffers, int numsamples);

/** \brief Returns the associated connection object on plugins with with the is_connection flag. */
zzub_connection_t *zzub_plugin_get_connection(zzub_plugin_t *plugin);

/** \brief Returns true if the plugin implements an embeddable user interface. */
/*bool*/ int zzub_plugin_has_embedded_gui(zzub_plugin_t *plugin);

/** \brief Attaches an embedded user interface to the provided parent window handle.
	Returns false if the plugin does not support embeddable user interface.
	This method exists as a common way to implement plugin-specific content in parameter views.
	The implementation depends on the plugin wrapper and the host operating system. */
/*bool*/ int zzub_plugin_create_embedded_gui(zzub_plugin_t *plugin, void *hwnd);

/** \brief Request resize of the embedded user interface.
	The plugin receives a suggested target size in the width and height parameters, but can choose to resize itself to any size and return the final width and height in the respective output parameters. These could differ from the target size when the user interface has a minimum or fixed size in any direction. */
void zzub_plugin_resize_embedded_gui(zzub_plugin_t *plugin, void *hwnd, int *width, int *height);

/* class PluginIterator */


/** \brief Helper iterator for a range of plugins. */

/** \brief Iterates to the next item. */
void zzub_plugin_iterator_next(zzub_plugin_iterator_t *pluginiterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_plugin_iterator_valid(zzub_plugin_iterator_t *pluginiterator);

/** \brief Returns the current item. */
zzub_plugin_t *zzub_plugin_iterator_current(zzub_plugin_iterator_t *pluginiterator);

/** \brief Destroys the iterator. */
void zzub_plugin_iterator_destroy(zzub_plugin_iterator_t *pluginiterator);

/* class Connection */


/** \brief Describes a connection between two plugins.
	There are three kinds of connections: Audio, MIDI and event connections.
	To create a connection, see zzub_player_create_audio_connection(), zzub_player_create_midi_connection() and zzub_player_create_event_connection(). */

/** \brief Destroys the connection and frees all resources. */
void zzub_connection_destroy(zzub_connection_t *connection);

/** \brief Returns the type of connection. See <see>zzub_connection_type</see> enumeration. */
int zzub_connection_get_type(zzub_connection_t *connection);

/** \brief Returns the 'from'-plugin. The plugin whose input signal this connection relates to. */
zzub_plugin_t *zzub_connection_get_from_plugin(zzub_connection_t *connection);

/** \brief Returns the 'to'-plugin. The receiver plugin of signals going through this connection. */
zzub_plugin_t *zzub_connection_get_to_plugin(zzub_connection_t *connection);

/** \brief Returns the underlying connection plugin which was created when the connection was made.
	E.g the audio connection plugin has automatable parameters for controlling amp on each channel. */
zzub_plugin_t *zzub_connection_get_connection_plugin(zzub_connection_t *connection);

/** \brief Audio connections: Returns the first input channel. */
int zzub_connection_get_first_input(zzub_connection_t *connection);

/** \brief Audio connections: Set the first input channel. */
void zzub_connection_set_first_input(zzub_connection_t *connection, int value);

/** \brief Audio connections: Returns the number of input channels. */
int zzub_connection_get_input_count(zzub_connection_t *connection);

/** \brief Audio connections: Set the number of input channels. */
void zzub_connection_set_input_count(zzub_connection_t *connection, int value);

/** \brief Audio connections: Returns the first output channel. */
int zzub_connection_get_first_output(zzub_connection_t *connection);

/** \brief Audio connections: Set the first output channel. */
void zzub_connection_set_first_output(zzub_connection_t *connection, int value);

/** \brief Audio connections: Returns the number of output channels. */
int zzub_connection_get_output_count(zzub_connection_t *connection);

/** \brief Audio connections: Set the number of output channels. */
void zzub_connection_set_output_count(zzub_connection_t *connection, int value);

/** \brief MIDI connections: Sets the name of the receiving MIDI device */
void zzub_connection_set_midi_device(zzub_connection_t *connection, const char *midi_device);

/** \brief MIDI connections: Returns the name of the receiving MIDI device */
const char *zzub_connection_get_midi_device(zzub_connection_t *connection);

/** \brief Event connections: Returns the number of event connection bindings. */
int zzub_connection_get_event_binding_count(zzub_connection_t *connection);

/** \brief Event connections: Adds an event connection binding. */
void zzub_connection_add_event_connection_binding(zzub_connection_t *connection, int sourceparam, int targetgroup, int targettrack, int targetparam);

/** \brief Event connections: Removes the event connection binding. */
void zzub_connection_remove_event_connection_binding(zzub_connection_t *connection, int sourceparam, int targetgroup, int targettrack, int targetparam);

/** \brief Event connections: Returns all current event bindings for an event connection. */
zzub_connection_binding_iterator_t *zzub_connection_get_event_binding_iterator(zzub_connection_t *connection);

/* class ConnectionBinding */


/** \brief Event connection binding between a controller plugin and a parameter on the connected plugin. */

/** \brief Returns the owner connection of this event binding. */
zzub_connection_t *zzub_connection_binding_get_connection(zzub_connection_binding_t *connectionbinding);

/** \brief Returns the parameter in group 3 on the source plugin being mapped. */
int zzub_connection_binding_get_source_column(zzub_connection_binding_t *connectionbinding);

/** \brief Returns the target parameter group. */
int zzub_connection_binding_get_target_group(zzub_connection_binding_t *connectionbinding);

/** \brief Returns the target parameter track. */
int zzub_connection_binding_get_target_track(zzub_connection_binding_t *connectionbinding);

/** \brief Returns the target parameter column. */
int zzub_connection_binding_get_target_column(zzub_connection_binding_t *connectionbinding);

/* class ConnectionBindingIterator */


/** \brief Collection of event connection bindings. */

/** \brief Iterates to the next item. */
void zzub_connection_binding_iterator_next(zzub_connection_binding_iterator_t *connectionbindingiterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_connection_binding_iterator_valid(zzub_connection_binding_iterator_t *connectionbindingiterator);

/** \brief Returns the current item. */
zzub_connection_binding_t *zzub_connection_binding_iterator_current(zzub_connection_binding_iterator_t *connectionbindingiterator);

/** \brief Resets the iterator to the start. */
void zzub_connection_binding_iterator_reset(zzub_connection_binding_iterator_t *connectionbindingiterator);

/** \brief Destroys the iterator. */
void zzub_connection_binding_iterator_destroy(zzub_connection_binding_iterator_t *connectionbindingiterator);

/* class Wave */


/** \brief Wave table */
int zzub_wave_get_id(zzub_wave_t *wave);
int zzub_wave_get_index(zzub_wave_t *wave);
int zzub_wave_clear(zzub_wave_t *wave);
const char *zzub_wave_get_name(zzub_wave_t *wave);
void zzub_wave_set_name(zzub_wave_t *wave, const char *name);
const char *zzub_wave_get_path(zzub_wave_t *wave);
void zzub_wave_set_path(zzub_wave_t *wave, const char *path);
int zzub_wave_get_flags(zzub_wave_t *wave);
void zzub_wave_set_flags(zzub_wave_t *wave, int flags);
float zzub_wave_get_volume(zzub_wave_t *wave);
void zzub_wave_set_volume(zzub_wave_t *wave, float volume);
int zzub_wave_get_envelope_count(zzub_wave_t *wave);
void zzub_wave_set_envelope_count(zzub_wave_t *wave, int count);
zzub_envelope_t *zzub_wave_get_envelope(zzub_wave_t *wave, int index);
void zzub_wave_set_envelope(zzub_wave_t *wave, int index, zzub_envelope_t *env);
int zzub_wave_get_level_count(zzub_wave_t *wave);
zzub_wavelevel_t *zzub_wave_get_level(zzub_wave_t *wave, int index);
zzub_wavelevel_t *zzub_wave_add_level(zzub_wave_t *wave);
void zzub_wave_remove_level(zzub_wave_t *wave, int level);

/* class Wavelevel */


/** \brief Wavelevel */
int zzub_wavelevel_get_id(zzub_wavelevel_t *wavelevel);
zzub_wave_t *zzub_wavelevel_get_wave(zzub_wavelevel_t *wavelevel);
int zzub_wavelevel_clear(zzub_wavelevel_t *wavelevel);
int zzub_wavelevel_get_sample_count(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_sample_count(zzub_wavelevel_t *wavelevel, int count);
int zzub_wavelevel_get_root_note(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_root_note(zzub_wavelevel_t *wavelevel, int note);
int zzub_wavelevel_get_samples_per_second(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_samples_per_second(zzub_wavelevel_t *wavelevel, int sps);
int zzub_wavelevel_get_loop_start(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_loop_start(zzub_wavelevel_t *wavelevel, int pos);
int zzub_wavelevel_get_loop_end(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_loop_end(zzub_wavelevel_t *wavelevel, int pos);
int zzub_wavelevel_get_format(zzub_wavelevel_t *wavelevel);
void zzub_wavelevel_set_format(zzub_wavelevel_t *wavelevel, int format);
int zzub_wavelevel_load_sample(zzub_wavelevel_t *wavelevel, int offset, int clear, const char *path, zzub_input_t *datastream);
int zzub_wavelevel_save_sample(zzub_wavelevel_t *wavelevel, zzub_output_t *datastream);
int zzub_wavelevel_save_sample_range(zzub_wavelevel_t *wavelevel, zzub_output_t *datastream, int start, int end);
void zzub_wavelevel_insert_sample_range(zzub_wavelevel_t *wavelevel, int start, void *buffer, int channels, int format, int numsamples);
void zzub_wavelevel_remove_sample_range(zzub_wavelevel_t *wavelevel, int start, int end);
void zzub_wavelevel_replace_sample_range(zzub_wavelevel_t *wavelevel, int start, void *buffer, int channels, int format, int numsamples);
void zzub_wavelevel_get_samples_digest(zzub_wavelevel_t *wavelevel, int channel, int start, int end, float *mindigest, float *maxdigest, float *ampdigest, int digestsize);
void zzub_wavelevel_get_slices(zzub_wavelevel_t *wavelevel, int *slicecount, int *slices);
void zzub_wavelevel_set_slices(zzub_wavelevel_t *wavelevel, int slicecount, const int *slices);

/** \brief Applies an offline plugin effect to the wave range. Requires the plugin_flag_is_offline. */
void zzub_wavelevel_process_sample_range_offline(zzub_wavelevel_t *wavelevel, int start, int end, zzub_plugin_t *plugin);

/* class Envelope */


/** \brief Envelopes */
unsigned short zzub_envelope_get_attack(zzub_envelope_t *envelope);
unsigned short zzub_envelope_get_decay(zzub_envelope_t *envelope);
unsigned short zzub_envelope_get_sustain(zzub_envelope_t *envelope);
unsigned short zzub_envelope_get_release(zzub_envelope_t *envelope);
void zzub_envelope_set_attack(zzub_envelope_t *envelope, unsigned short attack);
void zzub_envelope_set_decay(zzub_envelope_t *envelope, unsigned short decay);
void zzub_envelope_set_sustain(zzub_envelope_t *envelope, unsigned short sustain);
void zzub_envelope_set_release(zzub_envelope_t *envelope, unsigned short release);
char zzub_envelope_get_subdivision(zzub_envelope_t *envelope);
void zzub_envelope_set_subdivision(zzub_envelope_t *envelope, char subdiv);
char zzub_envelope_get_flags(zzub_envelope_t *envelope);
void zzub_envelope_set_flags(zzub_envelope_t *envelope, char flags);
int zzub_envelope_is_enabled(zzub_envelope_t *envelope);
void zzub_envelope_enable(zzub_envelope_t *envelope, int enable);
int zzub_envelope_get_point_count(zzub_envelope_t *envelope);
void zzub_envelope_get_point(zzub_envelope_t *envelope, int index, unsigned short *x, unsigned short *y, char *flags);
void zzub_envelope_set_point(zzub_envelope_t *envelope, int index, unsigned short x, unsigned short y, char flags);
void zzub_envelope_insert_point(zzub_envelope_t *envelope, int index);
void zzub_envelope_delete_point(zzub_envelope_t *envelope, int index);

/* class Mixer */


/** \brief Mixer Methods - provides access to the mixer in native plugins */

/* class ValidationErrorIterator */


/** \brief Contains validation warnings and errors.
	Validation errors are created when plugin incompabilities are detected.
	E.g if an older plugin was used to save a song, or was in the plugin cache. */

/** \brief Iterates to the next item. */
void zzub_validation_error_iterator_next(zzub_validation_error_iterator_t *validationerroriterator);

/** \brief Returns true if the iterator is valid and it is safe to call current() */
/*bool*/ int zzub_validation_error_iterator_valid(zzub_validation_error_iterator_t *validationerroriterator);

/** \brief Returns the current item. */
zzub_validation_error_t *zzub_validation_error_iterator_current(zzub_validation_error_iterator_t *validationerroriterator);

/** \brief Resets the iterator to the start. */
void zzub_validation_error_iterator_reset(zzub_validation_error_iterator_t *validationerroriterator);

/** \brief Destroys the iterator. */
void zzub_validation_error_iterator_destroy(zzub_validation_error_iterator_t *validationerroriterator);

/* class ValidationError */


/** \brief Used by song importers for details about compatibility problems with plugins and parameters during load. */

/** \brief Returns a value from the ValidationErrorType enum. */
int zzub_validation_error_get_type(zzub_validation_error_t *validationerror);

/** \brief Returns the parameter group.
	Used for parameter validation errors, otherwise undefined. */
int zzub_validation_error_get_group(zzub_validation_error_t *validationerror);

/** \brief Returns the parameter column.
	Used for parameter validation errors, otherwise undefined. */
int zzub_validation_error_get_column(zzub_validation_error_t *validationerror);

/** \brief Returns the original parameter value loaded from a song or the cache.
	Used for parameter validation errors, otherwise undefined. */
int zzub_validation_error_get_found_value(zzub_validation_error_t *validationerror);

/** \brief Returns the expected parameter value as reported by the plugin itself.
	Used for parameter validation errors, otherwise undefined. */
int zzub_validation_error_get_expected_value(zzub_validation_error_t *validationerror);

/** \brief Returns the original name of the parameter as loaded from a song or the cache.
	Used for parameter validation errors, otherwise undefined. */
const char *zzub_validation_error_get_parameter_name(zzub_validation_error_t *validationerror);

/** \brief Returns the original name of the affected plugin as loaded from a song or the cache. */
const char *zzub_validation_error_get_plugin_name(zzub_validation_error_t *validationerror);

/** \brief Returns the affected plugin loader. Could be a dummy.
	The returned pluginloader should not be used to create new plugin instances, but is rather intended for informational purposes. Such as displaying a load report to the user or inline song fixing. */
zzub_pluginloader_t *zzub_validation_error_get_pluginloader(zzub_validation_error_t *validationerror);

/* class Player */


/** \brief Player Methods */

/** \brief Creates a new player instance. */
zzub_player_t *zzub_player_create();

/** \brief Destroys the player instance and all its resources. */
void zzub_player_destroy(zzub_player_t *player);

/** \brief Inititializes the player.
	initialize() must be called only after the audio driver is set up. */
int zzub_player_initialize(zzub_player_t *player, int samplesPerSecond);

/** \brief Load an ARMZ project from disk.
	The filename can be a waveless uncompressed database, or a zipped .armz.
	mode=0: clear+load mode=1: import */
int zzub_player_load_armz(zzub_player_t *player, const char *fileName, int mode);

/** \brief Save current project to disk.
	If the filename has extension .armdb it is saved as waveless database.
	Unless the plugins array is empty, only data associated with the specified plugins is saved.
	Load warnings and error messages can be retreived with get_validation_errors(). */
int zzub_player_save_armz(zzub_player_t *player, const char *fileName, const zzub_plugin_t * *plugins, int plugincount);

/** \brief Imports a BMX from memory or file.
	Load warnings and error messages can be retreived with get_validation_errors(). */
int zzub_player_load_bmx(zzub_player_t *player, zzub_input_t *datastream, int flags, float x, float y);

/** \brief Imports an oldschool tracker module from disk. Supports MOD, IT, S3M.
	Imported songs use the built-in modplug plugin. */
int zzub_player_load_module(zzub_player_t *player, const char *fileName);

/** \brief Returns an iterator for all plugin validation errors.
	The caller must destroy the iterator. */
zzub_validation_error_iterator_t *zzub_player_get_validation_errors(zzub_player_t *player);

/** \brief Returns one of the values in the state enumeration. */
int zzub_player_get_state(zzub_player_t *player);

/** \brief Set player state. Takes one of the values in the state enumeration as parameter. */
void zzub_player_set_state(zzub_player_t *player, int state, int stoprow);

/** \brief Returns number of plugin loaders. */
int zzub_player_get_pluginloader_count(zzub_player_t *player);

/** \brief Returns a zzub_pluginloader_t handle by index. */
zzub_pluginloader_t *zzub_player_get_pluginloader(zzub_player_t *player, int index);

/** \brief Finds a zzub_pluginloader_t handle by uri. */
zzub_pluginloader_t *zzub_player_get_pluginloader_by_name(zzub_player_t *player, const char *name);

/** \brief Returns number of plugins in the current song. */
int zzub_player_get_plugin_count(zzub_player_t *player);
zzub_midimapping_t *zzub_player_add_midimapping(zzub_plugin_t *plugin, int group, int track, int param, int channel, int controller);
int zzub_player_remove_midimapping(zzub_plugin_t *plugin, int group, int track, int param);

/** \brief Returns the plugin object given the plugins name. */
zzub_plugin_t *zzub_player_get_plugin_by_name(zzub_player_t *player, const char *name);

/** \brief Returns the plugin object given the plugin id. See also zzub_plugin_get_id(). */
zzub_plugin_t *zzub_player_get_plugin_by_id(zzub_player_t *player, int id);

/** \brief Returns the plugin object given the plugins index in the graph. */
zzub_plugin_t *zzub_player_get_plugin(zzub_player_t *player, int index);

/** \brief Returns an iterator for all plugins. Faster than get_plugin_count()/get_plugin(). */
zzub_plugin_iterator_t *zzub_player_get_plugin_iterator(zzub_player_t *player);

/** \brief Returns an iterator for all patterns. Faster than get_pattern_count()/get_pattern(). */
zzub_pattern_iterator_t *zzub_player_get_pattern_iterator(zzub_player_t *player);

/** \brief Returns a pattern by its id. */
zzub_pattern_t *zzub_player_get_pattern_by_id(zzub_player_t *player, int id);

/** \brief Returns a pattern by its index, oldest first. */
zzub_pattern_t *zzub_player_get_pattern_by_index(zzub_player_t *player, int index);

/** \brief Returns a pattern event by its id. */
zzub_pattern_event_t *zzub_player_get_pattern_event_by_id(zzub_player_t *player, int id);

/** \brief Returns a suggested name for a new pattern */
void zzub_player_get_new_pattern_name(zzub_player_t *player, zzub_pattern_format_t *format, const char *description, char *name, int maxLen/*=1024*/);

/** \brief Returns total count of patterns. */
int zzub_player_get_pattern_count(zzub_player_t *player);

/** \brief Returns the index of the pattern with the given name */
zzub_pattern_t *zzub_player_get_pattern_by_name(zzub_player_t *player, const char *name);

/** \brief Returns the number of pattern formats. */
int zzub_player_get_pattern_format_count(zzub_player_t *player);

/** \brief Generates a name for a new pattern format. */
void zzub_player_get_new_pattern_format_name(zzub_player_t *player, const char *description, char *name, int maxLen/*=1024*/);

/** \brief Returns a pattern format by name. */
zzub_pattern_format_t *zzub_player_get_pattern_format_by_name(zzub_player_t *player, const char *name);

/** \brief Returns a pattern format by its index. */
zzub_pattern_format_t *zzub_player_get_pattern_format_by_index(zzub_player_t *player, int index);

/** \brief Returns a pattern format by its id. */
zzub_pattern_format_t *zzub_player_get_pattern_format_by_id(zzub_player_t *player, int id);

/** \brief Returns an iterator for all pattern formats. Faster than get_pattern_format_count()/get_pattern_format_by_index(). */
zzub_pattern_format_iterator_t *zzub_player_get_pattern_format_iterator(zzub_player_t *player);

/** \brief For silent processing. Safe to call in a separate thread. */
const float * *zzub_player_work_stereo(zzub_player_t *player, int *numSamples);

/** \brief Resets everything and clears the current project. */
void zzub_player_clear(zzub_player_t *player);

/** \brief Returns the number of waves in the wavetable (hardcoded to 200). */
int zzub_player_get_wave_count(zzub_player_t *player);

/** \brief Returns the wave by index in the range 0-199. */
zzub_wave_t *zzub_player_get_wave(zzub_player_t *player, int index);

/** \brief Adds a function that receives events. */
void zzub_player_add_callback(zzub_player_t *player, zzub_callback_t callback, void *tag);

/** \brief Removes a function that receives events. */
void zzub_player_remove_callback(zzub_player_t *player, zzub_callback_t callback, void *tag);

/** \brief Process player events.
	Intended to be called by the host in a timer or on idle processing to receive events about parameter changes etc. */
void zzub_player_handle_events(zzub_player_t *player);

/** \brief Returns the MIDI mapping by index. */
zzub_midimapping_t *zzub_player_get_midimapping(zzub_player_t *player, int index);

/** \brief Returns the number of MIDI mappings. */
int zzub_player_get_midimapping_count(zzub_player_t *player);

/** \brief Returns true if parameters are currently being recorded into patterns. */
/*bool*/ int zzub_player_get_automation(zzub_player_t *player);

/** \brief Set to true to begin recording parameter changes into patterns.
	Recording will reset on song stop. */
void zzub_player_set_automation(zzub_player_t *player, int enable);

/** \brief Returns true if the engine handles play/stop/seek MIDI messages on any open MIDI input devices. */
/*bool*/ int zzub_player_get_midi_transport(zzub_player_t *player);

/** \brief Set to true to handle MIDI play/stop/seek messages on any open MIDI input devices. */
void zzub_player_set_midi_transport(zzub_player_t *player, int enable);

/** \brief Returns the song comment. */
const char *zzub_player_get_infotext(zzub_player_t *player);

/** \brief Sets the song comment. */
void zzub_player_set_infotext(zzub_player_t *player, const char *text);

/** \brief Sets the plugin to receive MIDI data if the plugin's internal MIDI channel is set to the special channel 17 ("Play if selected"). */
void zzub_player_set_midi_plugin(zzub_player_t *player, zzub_plugin_t *plugin);

/** \brief Returns the current MIDI plugin. */
zzub_plugin_t *zzub_player_get_midi_plugin(zzub_player_t *player);

/** \brief Generates a new plugin name that can be used in a call to create_plugin(). */
void zzub_player_get_new_plugin_name(zzub_player_t *player, const char *uri, char *name, int maxLen/*=1024*/);

/** \brief Resets all internal keyjazz buffers. */
void zzub_player_reset_keyjazz(zzub_player_t *player);

/** \brief Create a new plugin
	If there was a problem during plugin creation, such as having an older version in the cache, warnings and error messages can be retreived with get_validation_errors(). */
zzub_plugin_t *zzub_player_create_plugin(zzub_player_t *player, zzub_input_t *input, int dataSize, const char *instanceName, zzub_pluginloader_t *loader, int flags/*=0*/);

/** \brief Create a new pattern */
zzub_pattern_t *zzub_player_create_pattern(zzub_player_t *player, zzub_pattern_format_t *format, const char *description, int rows);

/** \brief Clone a pattern */
zzub_pattern_t *zzub_player_clone_pattern(zzub_player_t *player, zzub_pattern_t *pattern, const char *description);

/** \brief Create a new pattern description */
zzub_pattern_format_t *zzub_player_create_pattern_format(zzub_player_t *player, const char *description);

/** \brief Clone a pattern format */
zzub_pattern_format_t *zzub_player_clone_pattern_format(zzub_player_t *player, zzub_pattern_format_t *format, const char *description);

/** \brief Rolls back all editing operations one step. Each step is defined with a call to zzub_player_history_commit(). */
void zzub_player_undo(zzub_player_t *player);

/** \brief Redoes all editing operations since last call to zzub_player_history_commit(). */
void zzub_player_redo(zzub_player_t *player);

/** \brief Enable/disable undo/redo recording. Returns the previous state. */
/*bool*/ int zzub_player_history_enable(zzub_player_t *player, int state);

/** \brief Sets user data for events sent by the engine. User data is valid until it is cleared in history_commit(). */
void zzub_player_history_begin(zzub_player_t *player, void *userdata);

/** \brief Commits the last operations to the mixer and undo buffer and marks a new undo step. */
void zzub_player_history_commit(zzub_player_t *player, int redo_id, int undo_id, const char *description);

/** \brief Returns the count of uncomitted operations. */
int zzub_player_history_get_uncomitted_operations(zzub_player_t *player);

/** \brief Clears the undo buffer and frees all associated resources. */
void zzub_player_history_reset(zzub_player_t *player);

/** \brief Returns the size of the undo buffer. */
int zzub_player_history_get_size(zzub_player_t *player);

/** \brief Returns the current position in the undo buffer. */
int zzub_player_history_get_position(zzub_player_t *player);

/** \brief Returns the description of an operation in the undo buffer. */
const char *zzub_player_history_get_description(zzub_player_t *player, int position);

/** \brief Set versioned, host-specific data. Plugins can retreive a pointer to this information with _host->get_host_info().
	Use and/or dependence on the host's version is regarded as bad practise and should not be used in new code. */
void zzub_player_set_host_info(zzub_player_t *player, int id, int version, void *host_ptr);

/** \brief Invokes event handlers for an internal event. */
int zzub_player_invoke_event(zzub_player_t *player, zzub_event_data_t *data, int immediate);

/** \brief Sets the order list length. */
void zzub_player_set_order_length(zzub_player_t *player, int length);

/** \brief Returns the order list length. */
int zzub_player_get_order_length(zzub_player_t *player);

/** \brief Sets a pattern in the order list by index. */
void zzub_player_set_order_pattern(zzub_player_t *player, int index, zzub_pattern_t *pattern);

/** \brief Returns a pattern from the order list by index. */
zzub_pattern_t *zzub_player_get_order_pattern(zzub_player_t *player, int index);

/** \brief Returns an iterator over all patterns in the orderlist. The iterator might contain NULLs for blank entries in the order list. */
zzub_pattern_iterator_t *zzub_player_get_order_iterator(zzub_player_t *player);

/** \brief Returns the order list loop start index. */
int zzub_player_get_order_loop_start(zzub_player_t *player);

/** \brief Sets the order list loop start index. */
void zzub_player_set_order_loop_start(zzub_player_t *player, int pos);

/** \brief Returns the order list loop end index. */
int zzub_player_get_order_loop_end(zzub_player_t *player);

/** \brief Sets the order list loop end index. */
void zzub_player_set_order_loop_end(zzub_player_t *player, int pos);

/** \brief Returns true if order list looping is enabled. */
int zzub_player_get_order_loop_enabled(zzub_player_t *player);

/** \brief Sets whether order list looping is enabled. */
void zzub_player_set_order_loop_enabled(zzub_player_t *player, int enable);

/** \brief Sets the order list queue index.
	The order list will skip to the queue index when the current pattern ends. */
void zzub_player_set_queue_order_index(zzub_player_t *player, int pos);

/** \brief Returns the current queue index. */
int zzub_player_get_queue_order_index(zzub_player_t *player);

/** \brief Timeshifts the orderlist play position. Does not actually change the order list contents.
	Adds a cookie on the undo buffer which adjusts the currently playing order list index accordingly, handling any race issues in the audio thread. */
void zzub_player_timeshift_order(zzub_player_t *player, int fromindex, int timeshift);

/** \brief Returns the current order list position. */
int zzub_player_get_position_order(zzub_player_t *player);

/** \brief Returns the current pattern position in the current order list pattern. */
int zzub_player_get_position_row(zzub_player_t *player);

/** \brief Returns the number of samples played since playback started. */
int zzub_player_get_position_samples(zzub_player_t *player);

/** \brief Sets the song position at an order list index and a pattern row. */
void zzub_player_set_position(zzub_player_t *player, int orderindex, int tick);

/** \brief Redundant? */
void zzub_player_adjust_position_order(zzub_player_t *player, int orderindex);

/** \brief Returns the global sequence BPM. */
float zzub_player_get_bpm(zzub_player_t *player);

/** \brief Returns the global sequence TBP. */
int zzub_player_get_tpb(zzub_player_t *player);

/** \brief Sets the global sequence BPM. */
void zzub_player_set_bpm(zzub_player_t *player, float bpm);

/** \brief Sets the global sequence TPB. */
void zzub_player_set_tpb(zzub_player_t *player, int tpb);

/** \brief Returns the number of available time sources in the project. */
int zzub_player_get_timesource_count(zzub_player_t *player);

/** \brief Returns the plugin for a time source. */
zzub_plugin_t *zzub_player_get_timesource_plugin(zzub_player_t *player, int index);

/** \brief Returns the plugin parameter group for a time source. */
int zzub_player_get_timesource_group(zzub_player_t *player, int index);

/** \brief Returns the plugin parameter track for a time source. */
int zzub_player_get_timesource_track(zzub_player_t *player, int index);

/** \brief Plays a single pattern.
	This merely starts playback for a single pattern and does not affect the global song state or counters. */
void zzub_player_play_pattern(zzub_player_t *player, zzub_pattern_t *pat, int row, int stoprow);

/** \brief Rendering hint; all plugins should be offset by this amount when rendered. */
void zzub_player_get_machineview_offset(zzub_player_t *player, double *x, double *y);

/** \brief Rendering hint; sets how much all plugins should be offset in the machine view. */
void zzub_player_set_machineview_offset(zzub_player_t *player, double x, double y);

/** \brief Returns the current number of mixer worker threads. Returns 1 by default. */
int zzub_player_get_thread_count(zzub_player_t *player);

/** \brief Changes the number of mixer worker threads. The threads argument must be greater than or equal to 1.
	When the thread count is 1, the engine processes one-by-one plugin sequentially.
	When the thread count is > 1, the engine distributes plugin processing across the requested number of threads. */
void zzub_player_set_thread_count(zzub_player_t *player, int threads);

/** \brief Returns max peak values for all channels from the most recent frame sent to the audio driver. */
void zzub_player_get_peaks(zzub_player_t *player, float *peaks, int *peakcount);

#if defined(__cplusplus)
} // extern "C"
#endif

#endif // __ZZUB_H
